diff -uNr POWER-Multi-GET-2.03/GET.pm POWER-Multi-GET-2.03ssl/GET.pm
--- POWER-Multi-GET-2.03/GET.pm	2003-01-10 17:00:16.000000000 +0200
+++ POWER-Multi-GET-2.03ssl/GET.pm	2003-01-10 16:59:48.000000000 +0200
@@ -17,6 +17,7 @@
 use POWER::lib qw( time sleep );
 use POWER::NB::Resolver 1.11;
 use POWER::NB::IO 1.11;		    # for ungzip large files
+use POWER::SSL;
 use Time::Local;		    # for cookie's expires
 use IPC::Open3;			    # for gzip without tmp files
 BEGIN { eval "use Compress::Zlib" } # instead of IPC::Open3 and POWER::NB::IO
@@ -24,7 +25,7 @@
 use vars qw($VERSION $Max_Traffic $Max_URL %Timeout %url $Proxy $SLEEP
     %CacheDNS $Max_CacheDNS $Max_Redirect $Headers $Headers_gzip $Use_gzip);
 
-$VERSION	= "2.03";
+$VERSION	= "2.03ssl";
 $Max_Traffic    = 10240000;	# maximum of read bytes in second
 $Max_URL	= 100;		# maximum of simultaneous processing url
 %CacheDNS	= ();
@@ -129,6 +130,7 @@
 	"Cookie: ".join("; ",@{$url{_cookie_header}})."\r\n" : "";
     my ($phost,$pport) = ($url{proxy}||$Proxy)=~m/^(?:http:\/\/)?([^:\/]+):(\d+)\/?$/;
     return("bad proxy",0) if (($url{proxy}||$Proxy) and not $phost);
+    return("can't proxy with https://",0) if $phost and $url{_sheme} eq "https";
     $url{_resolve} = $phost || $url{ip} || $url{_host};
     $url{_iport}   = $pport || $url{_port};
     $url{_request} = $url{_msg} = 
@@ -167,10 +169,16 @@
     return("wait for connect",$Timeout{Connecting},\&_connecting) unless 
     select(undef,$w,undef,0);
     return("connect: $!",0) if $!=ord getsockopt($url{_SOCK},SOL_SOCKET,SO_ERROR);
+    $url{_SOCK_SSL} = POWER::SSL->new($url{_SOCK}) if $url{_sheme} eq "https";
 }
 # write HTTP query to socket
+sub _syswrite {
+    $url{_sheme} eq "https" ?
+	$url{_SOCK_SSL}->sslwrite($_[1]) :
+	syswrite($url{_SOCK},     $_[1]) ;
+}
 sub _write {
-    my $n = syswrite($url{_SOCK},$url{_msg});
+    my $n = _syswrite($url{_SOCK},$url{_msg});
     return("wait for write",$Timeout{Writing},\&_write) if $! == EAGAIN;
     return("write: $!",0) if $! or not defined $n;
     return("written part of message",$Timeout{Writing},\&_write) if 
@@ -178,9 +186,15 @@
     $url{_READ_timeout} = $Now + $Timeout{Read};
 }
 # check $Max_Traffic, $Timeout{Read}, read HTTP header and content
+sub _sysread {
+    $url{_sheme} eq "https" ?
+	$url{_SOCK_SSL}->sslread($_[1], $_[2]) :
+	sysread($url{_SOCK},     $_[1], $_[2]) ;
+}
 sub _read {
     return("traffic limit",1,\&_read) if $Traffic >= $Max_Traffic;
-    my $n = sysread($url{_SOCK}, my $buf, Min($Max_Buf,$Max_Traffic-$Traffic));
+    my $n = _sysread($url{_SOCK}, my $buf, Min($Max_Buf,$Max_Traffic-$Traffic));
+    #print "_read: n=",(defined $n ? $n : "undef")," errno=",(defined $! ? "$!" : "undef"),"\n";
     if ($! == EAGAIN) {
     return("READ timeout",0) if $Now >= $url{_READ_timeout};
     return("data not ready to reading",$Timeout{Reading},\&_read);
@@ -191,6 +205,10 @@
     $url{_content} .= substr($buf,0,$n);
     # cut HTTP-header when we read it
     $url{_content} =~ s/^(.*?\r?\n)\r?\n/$url{_header}=$1;""/se unless $url{_header};
+    # HTTP/1.1 + SSL : socket isn't closed after sending html, so we try
+    # to detect received html manually
+    #$n = 0 if $url{_header} =~ /^Content-Length:\s*(\d+)/mi and
+    #	length($url{_content}) == $1;
     return("read in progress",0,\&_read) if $n != 0;
 }
 # check $Use_gzip, ungzip content if needed
